#!/usr/bin/env python3
import argparse
import random

from lib import *

parser = argparse.ArgumentParser(description='Generate a test case intended to kill `paul-cubic.cpp`.')
parser.add_argument('-seed', dest='seed', type=int, help='the random seed')

args = parser.parse_args()
random.seed(args.seed)

n = 5000
w = 5000

ks = list(range(w-9,w+1)) + [random.randint(3,8) for _ in range(n-10)]

random.shuffle(ks)

words = random_from_lengths(ks)
print(n, w)
print('\n'.join(words))
