#!/usr/bin/env python3
import random
import sys

random.seed(int(sys.argv[-1]))

n = int(sys.argv[1])
lon = float(sys.argv[2])

def covers(a, b):
    if (b-a) % 360 > (a-b) % 360:
        a,b = b,a

    return (lon-a)%360 + (b-lon)%360 == (b-a)%360

def opposite(a, b):
    return (a[1] - b[1]) % 360 == 180

print('%d' % n)

last = (random.randint(-89, 89), random.randint(-180, 179))
first = last
print('%d %d' % last)

for i in range(n-1):
    while True:
        cur = (random.randint(-89, 89), random.randint(-180, 179))
        if i == n-2 and (cur == first or opposite(cur, first)):
            continue
        if cur == last or opposite(cur, last):
            continue
        if i == n-2 and covers(cur[1], first[1]):
            continue
        if covers(cur[1], last[1]):
            continue
        break

    print('%d %d' % cur)
    last = cur


