#include <bits/stdc++.h>
using namespace std;

int main() {
	int n; cin >> n;
	
	vector<int> lat(n+1), lon(n+1);
	for (int i = 0; i < n; i++) {
		cin >> lat[i] >> lon[i];
	}
	lat[n] = lat[0], lon[n] = lon[0];

	bitset<360> visited;
	auto travel = [&](int lon1, int lon2) {
		while (lon1 != lon2) {
			visited[lon1+180] = true;
			if (++lon1 == 180) lon1 = -180;
		}
	};

	for (int i = 0; i < n; i++) {
		int dist = (lon[i+1]-lon[i]+360) % 360;

		if (dist < 180) {
			travel(lon[i], lon[i+1]);
		} else if (dist > 180) {
			travel(lon[i+1], lon[i]);
		} else {
		 	visited.set();
		}
	}

	// randomize the output a bit
	if (visited.all()) {
		cout << "yes" << endl;
	} else {
		srand(lat[0]);
		while (true) {
			int rand_lat = -180 + rand() % 360;
			if (!visited[rand_lat+180]) {
				double frac = 0.01 * (1 + rand() % 99);
				cout << "no " << rand_lat + frac << endl;
				break;
			}
		}
	}
}
