#!/usr/bin/env python3
from collections import defaultdict

data = defaultdict(lambda: defaultdict(int))

socks = int(input())
for i in range(0, socks):
    [style, type, count] = input().split()
    data[style][type] += int(count)

solvable = False
can_pull = 0
for style in data.values():
    left = style['left']
    right = style['right']
    any = style['any']
    if left>0 and right + any > 0:
        solvable = True
    if right>0 and left + any > 0:
        solvable = True
    if any > 1:
        solvable = True
    can_pull += max(left, right, min(any, 1))

if solvable:
    print(can_pull+1)
else:
    print("impossible")
