#!/usr/bin/env python3

import sys
import re

line = sys.stdin.readline()
assert re.match('^[1-9][0-9]*\n$', line, re.MULTILINE)
n = int(line)
assert 3 <= n <= 5 * 10**5

line = sys.stdin.readline()
assert re.match('^(0|[1-9][0-9]*)( (0|[1-9][0-9]*))*\n$', line, re.MULTILINE)

arr = list(map(int, line.strip().split()))
assert len(arr) == n

for x in arr:
    assert 0 <= x <= 10**13

assert not sys.stdin.read()
sys.exit(42)

