#include<iostream>
#include<vector>
using namespace std;

int run() {
	int n;
	cin >> n;
	vector<int> A(n+1), B(n+1);
	for (int i=0; i<n; i++)
		cin >> A[i] >> B[i],
		B[i] += 180;

	A[n] = A[0];
	B[n] = B[0];

	for (int i=0; i<n; i++)
		if (abs(B[i+1] - B[i]) == 180) return -1;

	bool taken[720] = {};
	for (int i=0; i<n; i++) {
		if (abs(B[i+1] - B[i]) < 180) {
			for (int j = 2*min(B[i], B[i+1]); j <= 2*max(B[i], B[i+1]); j++)
				taken[j] = true;
		} else {
			for (int j = 2*max(B[i], B[i+1]); j < 720; j++)
				taken[j] = true;
			for (int j = 2*min(B[i], B[i+1]); j >= 0; j--)
				taken[j] = true;
		}
	}

	for (int i=0; i < 720; i++)
		if (!taken[i]) return i;
	return -1;
}

int main() {
	(cout << fixed).precision(1);
	int res = run();
	if (res < 0) {
		cout << "yes" << endl;
	} else {
		cout << "no " << (double(res)*0.5 - 180.0) << endl;
	}
	return 0;
}
